#ifndef TASK_T_HH
#define TASK_T_HH

#include <systemc>
#include <scnsl.hh>
 
class Task_t:
    public Scnsl::Tlm::TlmTask_if_t
{
public:

    SC_HAS_PROCESS( Task_t );
 
    Task_t( const sc_core::sc_module_name modulename,
              const task_id_t id,
			  std::string behavior,
              Scnsl::Core::Node_t * n,
              const size_t proxies )
    throw ();

    /// @brief Virtual destructor.
    virtual
    ~Task_t()
    throw ();

    /// @name Inherited interface methods.
    //@{


    virtual
    void b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t );

    //@}

	unsigned int task_id;
private:

    /// @name Processes.
    //@{
  
	/// @brief Sender process.
    void _sendTemperature()
        throw ();

    /// @brief Disabled copy constructor.
    Task_t( const Task_t & );

    /// @brief Disabled assignment operator.
    Task_t & operator = ( Task_t & );
};

#endif
